/*
  Algorithms IE171- Lab11/Cryptography
  Author:  Menal Guzelsoy - 04/13 Spring 2004

  Input : argv[1]:Text File-A quoted text. 
          argv[2]:Key File, if exists.
  Output: Coded text and key file (if generated).
*/

/*------------------------------------------------------------------------*/
#include "rsa.hpp"

int main(int argc, char * argv[])
{
   char temp;
   string str, text;

   if(argc < 2){
      cout<<"main(): USAGE: executable textFile [keyFile]"<<endl;
      exit(1);
   }

   ifstream is(argv[1]);
   if(!is){
      cout<<"main(): Unable to open the text file!"<<endl;
      exit(1);
   }
   /* Read in the quoted string. Note that, if you are going to break the code,
      the text file should include the public key (used to encyript the
      text) at the first line. In that case, uncomment the following! */

   /*
     pair<INT, INT> key;
     is>>key.first>>key.second; 
   */

   while(true){
      if(is.get() == '\"'){
	 break;
      }
   }

   while((temp = is.get()) != '\"'){
      str+=temp;
   }
   is.close();
      
   RSA * rsa;
   
   if(argc > 2){  
      ifstream keyFile(argv[2]);
      rsa = new RSA(keyFile);
      keyFile.close();
   }
   else{
      rsa = new RSA();

      /* If you want to have your own keys or get new keys, 
	 use the following. It will print your keys out to a file named 
	 "myKeys.txt" */
      
      rsa->generateKeys(); 
   }

   /* for now, encode the text with your own public key */
   text = rsa->encode(str);
   cout<<"Encoded Text: "<<endl<<"\""<<text<<"\""<<endl<<endl;

   /* Uncomment the following, if you want to write the encoded text to 
      a file */

   /*
     ofstream os("myEncyriptedText.txt");
     os<<rsa->getPublicKey().first<<" "<<rsa->getPublicKey().second<<endl;
     os<<"\""<<text<<"\""<<endl;
   */

   /* Let's decode the encrypted text */
   text = rsa->decode(text);
   cout<<"Decoded text: "<<endl<<"\""<<text<<"\""<<endl<<endl;

   /* Uncomment the following if you want to break the given code.*/

   /* 
   text = rsa->breakCode(key);
   cout<<endl<<"Plain-Cracked Text: "<<endl<<text<<endl<<endl;
   */

   delete rsa;

   return 0;
}
 
